#ifndef CREDITS_H
#define CREDITS_H

#include "t3f/t3f.h"
#include "t3f/font.h"
#include "vfont.h"

#define MAX_CREDITS 256
#define MAX_CIMAGES  32

typedef struct
{

	char text[256];
	T3F_FONT ** font;
	int oy;
	ALLEGRO_COLOR color;

} CREDIT_ITEM;

typedef struct
{

	const char * fn;
	int ox;
	int oy;
	ALLEGRO_BITMAP * bp;

} CREDIT_IMAGE;

typedef struct
{

	CREDIT_ITEM item[MAX_CREDITS];
	int y, vy;
	int items;

	CREDIT_IMAGE image[MAX_CIMAGES];
	int fade_level;
	int fade_dir;
	int image_ticks;
	int images;
	int current_image;

	int done;

} CREDITS;

void credits_add_item(CREDITS * cp, char * text, T3F_FONT ** fp, int oy, ALLEGRO_COLOR color);
void credits_add_image(CREDITS * cp, const char * fn, int ox, int oy);
void credits_logic(CREDITS * cp);
void credits_render(ALLEGRO_BITMAP * bp, CREDITS * cp);

#endif
