#include "t3f/t3f.h"
#include "t3f/atlas.h"
#include "t3f/resource.h"
#include "globals.h"
#include "init.h"

static void vgolf_fix_reloaded_resources(void)
{
	int i;

	for(i = 0; i < VGOLF_MAX_FONTS; i++)
	{
		if(vgolf_font[i])
		{
			vgolf_font[i]->scale = 0.5;
		}
	}
	for(i = 0; i < VGOLF_MAX_PLAYERS; i++)
	{
		if(game_player[i].avatar)
		{
			vgolf_rebuild_avatar_from_source(game_player[i].avatar);
		}
	}
	if(game_course && main_game_vars.cur_hole < game_course->num_holes)
	{
		for(i = 0; i < MAX_HOLE_LAYERS; i++)
		{
			game_course->current_hole.layer_pic[i] = game_course->hole[main_game_vars.cur_hole].layer_pic[i];
		}
	}
	if(vgolf_credits.image[vgolf_credits.current_image].bp)
	{
		al_convert_mask_to_alpha(vgolf_credits.image[vgolf_credits.current_image].bp, al_get_pixel(vgolf_credits.image[vgolf_credits.current_image].bp, 0, 0));
	}
}

void vgolf_event_handler(ALLEGRO_EVENT * event, void * data)
{
	switch(event->type)
	{
		case ALLEGRO_EVENT_DISPLAY_RESUME_DRAWING:
		{
			t3f_event_handler(event);
			vgolf_fix_reloaded_resources();
			break;
		}
/*		case ALLEGRO_EVENT_KEY_CHAR:
		{
			if(event->keyboard.unichar == 'r')
			{
				printf("break 1\n");
				t3f_unload_atlases();
				printf("break 2\n");
				t3f_unload_resources();
				printf("break 3\n");
				t3f_show_resources();
				t3f_reload_resources();
				printf("break 4\n");
				t3f_rebuild_atlases();
				printf("break 5\n");
				vgolf_fix_reloaded_resources();
				printf("break 6\n");
			}
			t3f_event_handler(event);
			break;
		} */

		/* pass the event through to T3F for handling by default */
		default:
		{
			t3f_event_handler(event);
			break;
		}
	}
}
