#include "t3f/t3f.h"
#include "core/utility.h"

#include "globals.h"

void vgolf_play_sample(ALLEGRO_SAMPLE * sp, float vol, float pan, float speed)
{
	if(!vgolf_replay_seek)
	{
		t3f_play_sample(sp, vol, pan, speed);
	}
}

//play a random sound when the ball hits a wall
void play_ball_wall_hit_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_ball_collision[vgolf_rand()%MAX_SFX_COLLISION_SAMPLES], 1.0, 0.0, 1.0);
}


//plays the crowd's "ahh" sound
void play_ahhh_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_hole_ahhh[vgolf_rand()%MAX_SFX_HOLE_AHHH_SAMPLES], 1.0, 0.0, 1.0);
}

//plays a "bad job" sound effect
void play_poor_finish_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_hole_finish[0][vgolf_rand()%MAX_SFX_HOLE_FINISH_SAMPLES], 1.0, 0.0, 1.0);
}

//plays a "good job" sound effect
void play_good_finish_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_hole_finish[1][vgolf_rand()%MAX_SFX_HOLE_FINISH_SAMPLES], 1.0, 0.0, 1.0);
}

//play a random "hole-in-one" sample
void play_hole_in_one_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_hole_finish[2][vgolf_rand()%MAX_SFX_HOLE_FINISH_SAMPLES], 1.0, 0.0, 1.0);
}

//play the "ball hitting cup" sample
void play_ball_holesink_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_ball_holesink, 1.0, 0.0, 1.0);
}

//play the teleport sample
void play_ball_teleport_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_ball_teleport, 1.0, 0.0, 1.0);
}

//play the "splash" sound
void play_ball_splash_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_ball_splash, 1.0, 0.0, 1.0);
}

//plays the "zap" sample
void play_ball_zap_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_ball_zapped, 1.0, 0.0, 1.0);
}

/* [[new stuff */
//plays the "smash" sample
void play_ball_smash_sample(void)
{
}
/* new stuff]] */

//plays the club hitting ball sample
void play_club_ball_hit_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_swing[vgolf_rand() % MAX_SFX_SWING_SAMPLES], 1.0, 0.0, 1.0);
}

//plays the club rotation sample
void play_club_rotate_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_ball_rotate, 1.0, 0.0, 1.0);
}

//plays the sample associated with pressing enter and selecting a menu item
void play_select_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_menu_select, 1.0, 0.0, 1.0);
}

//plays the sample associated with hitting the esc key
void play_esc_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_menu_escape, 1.0, 0.0, 1.0);
}

//plays the sample associated with a menu slider changing value
void play_slider_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_menu_slider, 1.0, 0.0, 1.0);
}

//plays the sample associated with changing the current menu item selection
void play_item_select_sample(void)
{
	vgolf_play_sample(main_game_vars.sound_bank.sfx_menu_itemsel, 1.0, 0.0, 1.0);
}
