#include "t3f/t3f.h"
#include "t3f/animation.h"
#include "t3f/font.h"
#include "joynet/joynet.h"
#include "t3net/dlc.h"
#include "t3net/server_list.h"

#include "structs.h"
#include "core/avatar.h"
#include "profile.h"

ALLEGRO_COLOR    vgolf_color_black;
ALLEGRO_COLOR    vgolf_color_white;
ALLEGRO_COLOR    vgolf_color_box;
ALLEGRO_COLOR    vgolf_color_box_outline;
int              vgolf_mouse_x, vgolf_mouse_y, vgolf_mouse_z, vgolf_mouse_start_z, vgolf_mouse_b, vgolf_old_mouse_x, vgolf_old_mouse_y = 0;
//bool block_click = false;
bool locally_block_click = false;

T3F_ANIMATION * vgolf_title_bg = NULL;
T3F_ANIMATION * vgolf_title_deluxe = NULL;
float vgolf_title_offset_x = 0.0;
T3F_ANIMATION * vgolf_title_course_preview = NULL;

/* new stuff */
int vgolf_frames;
int vgolf_ticks = 0;
int vgolf_state = VGOLF_STATE_LOAD;
ALLEGRO_BITMAP * scorecard_pic = NULL;
int done = 0;
TITLE_LETTER letter[5];
T3F_FONT * vgolf_font[VGOLF_MAX_FONTS] = {NULL};
int players = 2;
VGOLF_COURSE_DATABASE vgolf_courses;
VGOLF_AVATAR_DATABASE vgolf_avatars;
VGOLF_COMMENTARY_DATABASE vgolf_commentaries;
PROFILE_LIST vgolf_profiles;
ALLEGRO_COLOR menu_bg_color;

int network_play = 0;

int vgolf_config[CONFIG_MAX] = {0};
char vgolf_nick[128] = {0};
char vgolf_host_name[128] = {0};
char old_vgolf_nick[128] = {0};

char fname_buffer[1024] = {0};

//debugging stuff (remove later)
int v_tag = 0;
int vl_tag = 0;
int orth_tag = 0;
int r_tag = 0;
VERTEX vert_tag;
volatile int game_speed_counter = 0;
char debug_str[64];

char entered_text[1024] = {0};
char old_entered_text[256] = {0};
int entered_text_max = 255;
int entering_text = 0;
int entered_text_pos;
NCDMSG_QUEUE vgolf_messages;
CREDITS vgolf_credits;

char text_buffer[256];

unsigned long left_click = 0;
unsigned long right_click = 0;

/* networking */
bool vgolf_hosting = false;
JOYNET_CLIENT * vgolf_client = NULL;
JOYNET_GAME * vgolf_client_game = NULL;
char vgolf_network_id[256] = {0};
char vgolf_network_ip[256] = {0};
T3NET_SERVER_LIST * vgolf_server_list = NULL;
char vgolf_server_name[256] = {0};
bool vgolf_client_disconnected = false;
bool vgolf_lan_play = false;
unsigned long vgolf_seed = 0;
unsigned long vgolf_selected_course = 0;
int vgolf_low_bandwidth_mode = 0;
int vgolf_chat_state = 0;
int vgolf_chat_offset_x = 0;
bool vgolf_chat_new_message = false;
float vgolf_chat_width = 0.0;
char vgolf_chat_page_text[64] = {'<'};
bool vgolf_passing_turn = false; // halt gameplay processing until turn pass is finished
int vgolf_passed_turn_frame = -1;
ALLEGRO_FILE * vgolf_chat_log_file = NULL;
int vgolf_start_game_timer = 0;

/* DLC */
T3NET_DLC_LIST * vgolf_dlc_courses = NULL;
T3NET_DLC_LIST * vgolf_dlc_avatars = NULL;
T3NET_DLC_LIST * vgolf_dlc_commentaries = NULL;

/* gameplay */
int vgolf_player_count;
int vgolf_player_list[VGOLF_MAX_PLAYERS] = {0};
int vgolf_remove_player[VGOLF_MAX_PLAYERS] = {0};
int vgolf_remove_player_frame[VGOLF_MAX_PLAYERS] = {0};
bool vgolf_upload_list[VGOLF_MAX_PLAYERS];
int debug_mode = 0;
int vgolf_start_hole = 0;
int next_hole;
bool vgolf_local_club_blocked = false;

int scount;
PLAYER game_player[VGOLF_MAX_PLAYERS];
MAIN_GAME_VARS main_game_vars;
VGOLF_COURSE * game_course = NULL;
V_MESSAGE game_vmessage[GAME_VMESSAGE_QUEUE_SIZE];
PLAYER * current_player = NULL;
HOLE * current_hole = NULL;

ALLEGRO_SAMPLE * csample = NULL;
int cvtime = 0;
float cvlength;

float lc_cx, lc_cy, lc_cr;
int lc_collided;

char vgolf_music_fn[1024] = {0};
int vgolf_hidden_layer = -1;

bool vgolf_skip_leaderboard = true;
int vgolf_leaderboard_num_holes = 0;
int vgolf_game_mouse_x, vgolf_game_mouse_y, vgolf_game_mouse_z, vgolf_game_mouse_b;
int vgolf_local_mouse_x, vgolf_local_mouse_y, vgolf_local_mouse_z, vgolf_local_mouse_b;
int vgolf_old_mouse_x, vgolf_old_mouse_y, vgolf_old_mouse_z, vgolf_old_mouse_b;
int vgolf_touch_mouse_x, vgolf_touch_mouse_y, vgolf_touch_mouse_z, vgolf_touch_mouse_b;
bool vgolf_game_block_click = false;
bool vgolf_replay_seek = false;
int vgolf_replay_slowmo_tick = 0;
bool vgolf_replay_paused = false;
bool vgolf_demo = true;
