#ifndef VGOLF_GLOBALS_H
#define VGOLF_GLOBALS_H

#include "structs.h"
#include "profile.h"
#include "t3net/server_list.h"

extern ALLEGRO_COLOR    vgolf_color_black;
extern ALLEGRO_COLOR    vgolf_color_white;
extern ALLEGRO_COLOR    vgolf_color_box;
extern ALLEGRO_COLOR    vgolf_color_box_outline;
extern int              vgolf_mouse_x, vgolf_mouse_y, vgolf_mouse_z, vgolf_mouse_start_z, vgolf_mouse_b, vgolf_old_mouse_x, vgolf_old_mouse_y;
//extern bool block_click;
extern bool locally_block_click;

extern T3F_ANIMATION * vgolf_title_bg;
extern T3F_ANIMATION * vgolf_title_deluxe;
extern float vgolf_title_offset_x;
extern T3F_ANIMATION * vgolf_title_course_preview;

/* new stuff */
extern int vgolf_frames;
extern int vgolf_ticks;
extern int vgolf_state;
extern ALLEGRO_BITMAP * scorecard_pic;
extern int done;
extern TITLE_LETTER letter[5];
extern T3F_FONT * vgolf_font[VGOLF_MAX_FONTS];
extern int players;
extern VGOLF_COURSE_DATABASE vgolf_courses;
extern VGOLF_AVATAR_DATABASE vgolf_avatars;
extern VGOLF_COMMENTARY_DATABASE vgolf_commentaries;
extern PROFILE_LIST vgolf_profiles;
extern ALLEGRO_COLOR menu_bg_color;

extern int network_play;

extern int vgolf_config[CONFIG_MAX];
extern char vgolf_nick[128];
extern char vgolf_host_name[128];
extern char old_vgolf_nick[128];

extern char fname_buffer[1024];

//debugging stuff (remove later)
extern int v_tag;
extern int vl_tag;
extern int orth_tag;
extern int r_tag;
extern VERTEX vert_tag;
extern volatile int game_speed_counter;
extern char debug_str[64];

extern char entered_text[1024];
extern char old_entered_text[256];
extern int entered_text_max;
extern int entering_text;
extern int entered_text_pos;
extern NCDMSG_QUEUE vgolf_messages;
extern CREDITS vgolf_credits;

extern char text_buffer[256];

extern unsigned long left_click;
extern unsigned long right_click;

/* networking */
extern bool vgolf_hosting;
extern JOYNET_CLIENT * vgolf_client;
extern JOYNET_GAME * vgolf_client_game;
extern char vgolf_network_id[256];
extern char vgolf_network_ip[256];
extern T3NET_SERVER_LIST * vgolf_server_list;
extern char vgolf_server_name[256];
extern bool vgolf_client_disconnected;
extern bool vgolf_lan_play;
extern unsigned long vgolf_seed;
extern unsigned long vgolf_selected_course;
extern int vgolf_low_bandwidth_mode;
extern int vgolf_chat_state;
extern int vgolf_chat_offset_x;
extern bool vgolf_chat_new_message;
extern float vgolf_chat_width;
extern char vgolf_chat_page_text[64];
extern bool vgolf_passing_turn; // halt gameplay processing until turn pass is finished
extern int vgolf_passed_turn_frame;
extern ALLEGRO_FILE * vgolf_chat_log_file;
extern int vgolf_start_game_timer;

/* DLC */
extern T3NET_DLC_LIST * vgolf_dlc_courses;
extern T3NET_DLC_LIST * vgolf_dlc_avatars;
extern T3NET_DLC_LIST * vgolf_dlc_commentaries;

/* gameplay */
extern int vgolf_player_count;
extern int vgolf_player_list[VGOLF_MAX_PLAYERS];
extern int vgolf_remove_player[VGOLF_MAX_PLAYERS];
extern int vgolf_remove_player_frame[VGOLF_MAX_PLAYERS];
extern bool vgolf_upload_list[VGOLF_MAX_PLAYERS];
extern int debug_mode;
extern int vgolf_start_hole;
extern int next_hole;
extern bool vgolf_local_club_blocked;

extern int scount;
extern PLAYER game_player[VGOLF_MAX_PLAYERS];
extern MAIN_GAME_VARS main_game_vars;
extern VGOLF_COURSE * game_course;
extern V_MESSAGE game_vmessage[GAME_VMESSAGE_QUEUE_SIZE];
extern PLAYER * current_player;
extern HOLE * current_hole;

extern ALLEGRO_SAMPLE * csample;
extern int cvtime;
extern float cvlength;

extern float lc_cx, lc_cy, lc_cr;
extern int lc_collided;

extern char vgolf_music_fn[1024];
extern int vgolf_hidden_layer;

extern int vgolf_leaderboard_num_holes;
extern bool vgolf_skip_leaderboard;
extern int vgolf_game_mouse_x, vgolf_game_mouse_y, vgolf_game_mouse_z, vgolf_game_mouse_b;
extern int vgolf_local_mouse_x, vgolf_local_mouse_y, vgolf_local_mouse_z, vgolf_local_mouse_b;
extern int vgolf_old_mouse_x, vgolf_old_mouse_y, vgolf_old_mouse_z, vgolf_old_mouse_b;
extern int vgolf_touch_mouse_x, vgolf_touch_mouse_y, vgolf_touch_mouse_z, vgolf_touch_mouse_b;
extern bool vgolf_game_block_click;
extern bool vgolf_replay_seek;
extern int vgolf_replay_slowmo_tick;
extern bool vgolf_replay_paused;
extern bool vgolf_demo;

#endif
