#ifndef VGOLF_MENU_PROC_H
#define VGOLF_MENU_PROC_H

#include "t3net/t3net.h"
#include "t3net/leaderboard.h"
#include "hyperlink.h"
#include "newmenu.h"
#include "gameplay.h"

#define VGOLF_MENU_MIN_Y                  0
#define VGOLF_MENU_MAX_Y                480

#define VGOLF_MENU_TITLE                  0

#define VGOLF_MENU_MAIN                   1
#define VGOLF_MENU_OPTIONS                2
    #define VGOLF_MENU_OPTIONS_VIDEO      3
    #define VGOLF_MENU_OPTIONS_AUDIO      4
    #define VGOLF_MENU_OPTIONS_ONLINE     5
    #define VGOLF_MENU_OPTIONS_GAMEPLAY   6

#define VGOLF_MENU_IN_GAME                7
#define VGOLF_MENU_GOPTIONS               8
    #define VGOLF_MENU_GOPTIONS_VIDEO     9
    #define VGOLF_MENU_GOPTIONS_AUDIO    10
    #define VGOLF_MENU_GOPTIONS_ONLINE   11
    #define VGOLF_MENU_GOPTIONS_GAMEPLAY 12

#define VGOLF_MENU_PROFILE_DELETE        13
#define VGOLF_MENU_NAME_ENTRY            14
#define VGOLF_MENU_EXIT_GAME             15
#define VGOLF_MENU_UPLOAD_FAIL           16
#define VGOLF_MENU_PLAY                  17

/* online play menus */
#define VGOLF_MENU_PLAY_ONLINE           18
#define VGOLF_MENU_PLAY_ONLINE_HOST      19
#define VGOLF_MENU_PLAY_ONLINE_JOIN      20
#define VGOLF_MENU_HOST_NAME             21
#define VGOLF_MENU_MAIN_HOST             22
#define VGOLF_MENU_HOST_LIST             23
#define VGOLF_MENU_MAIN_JOIN             24
#define VGOLF_MENU_NICK                  25

#define VGOLF_MENU_DLC                   36

/* hyperlink pages to supplement menus */
extern HYPERLINK_PAGE * player_page[VGOLF_MAX_PLAYERS];
extern HYPERLINK_PAGE * player_network_page[VGOLF_MAX_PLAYERS];
extern HYPERLINK_PAGE * player_start_page[VGOLF_MAX_PLAYERS];
extern HYPERLINK_PAGE * level_select_page;
extern HYPERLINK_PAGE * player_page_pointer[VGOLF_MAX_PLAYERS];
extern HYPERLINK_PAGE * player_add_page;
extern HYPERLINK_PAGE * player_global_page;
extern HYPERLINK_PAGE * player_global_slave_page;
extern HYPERLINK_PAGE * course_global_page;
extern HYPERLINK_PAGE * course_global_slave_page;
extern HYPERLINK_PAGE * player_avatar_page;
extern HYPERLINK_PAGE * player_dlc_avatar_page;
extern HYPERLINK_PAGE * player_account_page;
extern HYPERLINK_PAGE * player_new_account_page;
extern HYPERLINK_PAGE * profile_page;
extern HYPERLINK_PAGE * leaderboard_page;
extern HYPERLINK_PAGE * profile_global_page;
extern HYPERLINK_PAGE * leaderboard_global_page;
extern HYPERLINK_PAGE * game_complete_page;
extern HYPERLINK_PAGE * sub_menu_page;
extern HYPERLINK_PAGE * scoreboard_page;
extern HYPERLINK_PAGE * course_page;
extern HYPERLINK_PAGE * ball_drop_page;
extern HYPERLINK_PAGE * take_gimme_page;
extern HYPERLINK_PAGE * fake_ball_drop_page;
extern HYPERLINK_PAGE * fake_take_gimme_page;
extern HYPERLINK_PAGE * fake_scoreboard_page;
extern HYPERLINK_PAGE * fake_game_complete_page;
extern HYPERLINK_PAGE * chat_page;
extern HYPERLINK_PAGE * dlc_page;
extern char player_page_text_buffer[VGOLF_MAX_PLAYERS][256];
extern bool fake_page_hidden; // don't draw fake pages when this is set to 'true'

extern NEWMENU * nmenu[256];

extern T3NET_LEADERBOARD * leaderboard;
extern int leaderboard_mode;
extern char leaderboard_menu_text[32];

extern int profile_course;
extern int selected_profile;
extern int selected_course;
extern int show_records;
extern int profile_show_details;
extern char profile_text[16][256];
extern char temp_text[256];
extern int last_commentary;
extern int vgolf_player_choosing;

int hl_player_name(int p, void * pp);
void play_proc(void);
void vgolf_menu_proc_dlc_courses(void);
void vgolf_menu_proc_dlc_avatars(void);
void vgolf_menu_proc_dlc_commentaries(void);
void vgolf_open_chat_log(void);
void vgolf_close_chat_log(void);
void vgolf_log_chat(const char * user, const char * text);
void vgolf_set_up_menus(void);
void vgolf_destroy_menus(void);
void vgolf_menu_proc_begin_hosting(void);
void vgolf_menu_proc_accept_name(void);
int vgolf_menu_proc_toggle_chat(int i, void * p);
bool vgolf_create_dlc_page(void);
void vgolf_destroy_dlc_lists(void);

#endif
