#include <string.h>
#include "message.h"
#include "vfont.h"

void outline_text(T3F_FONT * fp, int x, int y, ALLEGRO_COLOR c1, ALLEGRO_COLOR c2, const char * buffer)
{
	t3f_draw_text(fp, c1, x, y, 0.0, 0.0, 0.0, 0, buffer);
}

void outline_text_shadow(T3F_FONT * fp, int x, int y, int sx, int sy, ALLEGRO_COLOR c1, ALLEGRO_COLOR c2, ALLEGRO_COLOR c3, float tab, const char * buffer)
{
	t3f_draw_text(fp, c3, x + sx, y + sy, 0.0, 640.0, tab, 0, buffer);
	t3f_draw_text(fp, c1, x, y, 0.0, 640.0, tab, 0, buffer);
}

void outline_text_shadow2(T3F_FONT * fp, int x, int y, int sx, int sy, ALLEGRO_COLOR c1, ALLEGRO_COLOR c2, ALLEGRO_COLOR c3, float tab, const char * buffer)
{
	t3f_draw_text(fp, c3, x + sx, y + sy, 0.0, 0.0, tab, 0, buffer);
	t3f_draw_text(fp, c1, x, y, 0.0, 0.0, tab, 0, buffer);
}

void outline_text_shadow_center(T3F_FONT * fp, int x, int y, int sx, int sy, ALLEGRO_COLOR c1, ALLEGRO_COLOR c2, ALLEGRO_COLOR c3, const char * buffer)
{
	float dx;

	dx = x - t3f_get_text_width(fp, buffer) / 2;
	t3f_draw_text(fp, c3, dx + sx, y + sy, 0.0, 640.0, 0.0, 0, buffer);
	t3f_draw_text(fp, c1, dx, y, 0.0, 640.0, 0.0, 0, buffer);
}

void shadow_sprite(ALLEGRO_BITMAP * sprite, int x, int y, int sx, int sy, ALLEGRO_COLOR sc)
{
	al_draw_tinted_bitmap(sprite, sc, x + sx, y + sy, 0);
	al_draw_bitmap(sprite, x, y, 0);
}

void ncdmsg_delete(NCDMSG_QUEUE * qp, int msg)
{
	int j;

	for(j = msg + 1; j < qp->messages; j++)
	{
		strcpy(qp->message[j - 1].text, qp->message[j].text);
		qp->message[j - 1].time = qp->message[j].time;
		qp->message[j - 1].color = qp->message[j].color;
		qp->message[j - 1].tab = qp->message[j].tab;
	}
	qp->message[j].time = 0;
	qp->messages--;
}

void ncdmsg_add(NCDMSG_QUEUE * qp, char * dp, ALLEGRO_COLOR color, float tab, int time)
{
	if(qp->messages >= NCDMSG_MAX)
	{
		ncdmsg_delete(qp, 0);
	}
	strcpy(qp->message[qp->messages].text, dp);
	qp->message[qp->messages].time = time;
	qp->message[qp->messages].color = color;
	qp->message[qp->messages].tab = tab;
	qp->messages++;
}

void ncdmsg_clear(NCDMSG_QUEUE * qp)
{
	int i;

	for(i = qp->messages - 1; i >= 0; i--)
	{
		if(qp->message[i].time <= 0)
		{
			ncdmsg_delete(qp, i);
		}
	}
}

void ncdmsg_logic(NCDMSG_QUEUE * qp)
{
	int i;

	for(i = qp->messages - 1; i >= 0; i--)
	{
		if(qp->message[i].time > 0)
		{
			qp->message[i].time--;
			if(qp->message[i].time <= 0)
			{
				ncdmsg_delete(qp, i);
			}
		}
	}
}
