#ifndef VFONT_H
#define VFONT_H

#include "t3f/t3f.h"
#include "t3f/font.h"
#include "core/poly.h"

#define V_MESSAGE_MAX_LENGTH 32
#define VMSG_TEXT_PLAIN 0
#define VMSG_TEXT_SCALE_ALL_VERT_FREEZE 1
#define VMSG_TEXT_ENTER_FROMRIGHT 2
#define VMSG_TEXT_ENTER_FROMBOTTOM 4
#define VMSG_TEXT_ENTER_FROMLEFT 5
#define VMSG_TEXT_ENTER_FROMTOP 6
#define VMSG_TEXT_ENTER_FROMRIGHT_SCALED 8
#define VMSG_TEXT_ENTER_FROMBOTTOM_SCALED 9
#define VMSG_TEXT_ENTER_FROMLEFT_SCALED 10
#define VMSG_TEXT_ENTER_FROMTOP_SCALED 11
#define VMSG_TEXT_SCALE_ALL 3
#define VMSG_TEXT_SCALE_ALL_CENTERED 15
#define VMSG_TEXT_ROTATE_ALL 7
#define VMSG_TEXT_FLOAT 12
#define VMSG_TEXT_FLOAT_CENTERED 13

typedef struct
{
//        V_LETTER c[V_MESSAGE_MAX_LENGTH];
//        char c[V_MESSAGE_MAX_LENGTH];
        VERTEX v,s;
        char txt[V_MESSAGE_MAX_LENGTH];
        int length;                       //length of string/message
        short attrib_ref[4];
        short timer;
        short timer_end;
        char method;
        int active;
        }V_MESSAGE;

void vgolf_draw_rotated_text(T3F_FONT * fp, ALLEGRO_COLOR color, float x, float y, float angle, char * text);
void vgolf_draw_scaled_text(T3F_FONT * fp, ALLEGRO_COLOR color, float x, float y, float scale, char * text);

void vfont_message_scale_logic(V_MESSAGE * vmsg, char method, char increment);
void vfont_message_float_logic(V_MESSAGE * vmsg, char method, char increment);
void vfont_message_move_logic(T3F_FONT * vf, V_MESSAGE * vmsg, char method, char increment, int dir, float scale);
void vfont_message_rotate_logic(V_MESSAGE * vmsg, char method, char increment);
void vfont_message_logic(T3F_FONT * vf, V_MESSAGE * vmsg, char method, char increment);
void vfont_message_textout(ALLEGRO_BITMAP * bp, T3F_FONT * vf, V_MESSAGE * vmsg, char method, char increment);
void set_vfont_message(V_MESSAGE * vmsg, T3F_FONT * vf, char * txt, int x, int y, int z, char method, int m_ref1, int m_ref2, int m_ref3, int m_ref4, int t_end);
void deactivate_vfont_message(V_MESSAGE * vmsg);
void add_vfont_queue_message(V_MESSAGE vmsg[], int num_vmessages, T3F_FONT * vf, int * cur_slot, char * txt, int x, int y, int z, char method, int m_ref1, int m_ref2, int m_ref3, int m_ref4, int t_end);

#endif
